/*
** benchmark.d
** Copyright (C) 2003 Helmut Leitner
** Donated to Digital Mars.
** Released under the GNU GPL, see LICENSE.TXT
** and http://www.gnu.org/copyleft/gpl.html
*/

module venus.timer;
import venus.all;

extern (Windows) int QueryPerformanceFrequency(ulong* lpFrequency);
extern (Windows) int QueryPerformanceCounter(ulong* lpCounter);

alias QueryPerformanceCounter TimerGetCount;

ulong TimerFrequency;
double TimerSecFactor=1/1193180.0;

static this()
{
    QueryPerformanceFrequency(&TimerFrequency);
    TimerSecFactor=1/(double)TimerFrequency;
}

void TimerGetCountFunc(ulong* pcount)
{
    QueryPerformanceCounter(pcount);
}

double TimerCountRetSec(ulong count)
{
    return count*TimerSecFactor;
}

ulong TimerRetCount()
{
    ulong ret;
    QueryPerformanceCounter(&ret);
    return ret;
}
